#include "allegro.h"
#include <ApplicationServices/ApplicationServices.h>
#include <iostream>
#include <math.h>
#include <vector>

//change background colour depending on performance

void init();
void deinit();

const int NONOTE=-60;
const int notecount=12*4+1;
int canon[notecount]={
0 ,
7 ,
10 ,
5 ,

7 ,
NONOTE ,
5 ,
NONOTE ,

3 ,
2 ,
7 ,
NONOTE ,

8 ,
NONOTE ,
7 ,
NONOTE ,

5 ,
2 ,
3 ,
-2 ,

-4 ,
NONOTE ,
-5 ,
-2 ,

2 ,
3 ,
2 ,
NONOTE ,

NONOTE ,
-2 ,
3 ,
7 ,

14 ,
NONOTE ,
9 ,
7 ,

6 ,
NONOTE ,
12 ,
15 ,

17 ,
9 ,
7 ,
12 ,

10 ,
12 ,
3 ,
6,

7
};

int noteindex=0;


int min(int a, int b)
{
	if (a<b) return a;
	else return b;    
}

int max(int a,int b)
{
	if (a>b)  return a;
	else return b;
}
const int pan = 128;
const int pitch = 1000;

const int playerwidth=32;

SAMPLE *sound;

BITMAP *buffer;


/* FRAMERATE CONTROL*/


volatile unsigned int frames, fps;
void second_counter(void)
{
	fps=frames;
	frames=0;
} END_OF_FUNCTION(second_counter);
int timewaster_delay;
extern void do_prog(void);

volatile unsigned int ticks;
void ticker(void)
{
	++ticks;
} END_OF_FUNCTION(ticker);


enum GameState { gs_prefaces, gs_game, gs_postlude};
GameState gamestate;

class Drop {
public:
	int x;
	int y;
	int t;
	bool move();
	void draw();
	Drop(int ix): x(ix),y(0),t(0){};
};

bool Drop::move() {
	t++;
	y=t*3/4;
	
	if (t==30*4)
		return false;
	else return true;
		
};

void Drop::draw()
{
	rectfill(buffer, x, y, x+4, y+4, makecol(0,0,255));
}

void playnote(int a)
{
	play_sample(sound, 255, pan, (pow(13.0/12,a)*1000.0), 0);
}

using namespace std;

int main() {
	
    
	int px=30;

	int score=0;
	int statetimer=0;
	int playtimer=0;
	int prefacescreen=0;
	bool spaceup=true;
	
	init();
	
	vector <Drop> drops;
	bool quit=false;
	
	while (!key[KEY_ESC]&&!quit) 
	{
		clear_bitmap(buffer);
		int t = 255*score / notecount;
		clear_to_color(buffer, makecol(t,t,t));
			
		switch (gamestate)
		{
			case gs_prefaces:
				if (statetimer>-10)
				{
					if (statetimer<254)
						statetimer+=2;

					switch (prefacescreen)
					{
						case 0:
							textout_ex(buffer, font, "increpare presents", 4, 16, makecol(255,255,255),makecol(0,0,0));
							break;
						case 1:
							textout_ex(buffer, font, "lacrimosa", 4, 16, makecol(255,255,255),makecol(0,0,0));
							break;
						case 2:
							break;
						case 3:
							textout_ex(buffer, font, "Years ago,", 4, 16, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "my wife had a", 4, 30, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "miscarriage.", 4, 44, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "She cried so much", 4, 62, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "when she came home.", 4, 76, makecol(255,255,255),makecol(0,0,0));
							break;
						case 4:
							textout_ex(buffer, font, "I tried to console", 4, 30, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "her.", 4, 44, makecol(255,255,255),makecol(0,0,0));
							break;
						case 5:
							textout_ex(buffer, font, "I tried to console", 4, 30, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "her.", 4, 44, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "To bear her", 4, 62, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "burden of tears.", 4, 76, makecol(255,255,255),makecol(0,0,0));
							break;

					}
					if (key[KEY_SPACE])
					{
						if (spaceup)
						{
							statetimer=-100;
							spaceup=false;
						}
					}
					else
						spaceup=true;
						
						
				}
				else
				{
					if (prefacescreen<5)
					{
						prefacescreen++;
						statetimer=0;
					}
					else
					{
						gamestate=gs_game;
						statetimer=-50;
					}
				}
				break;
			case gs_game:
				statetimer++;
				textout_ex(buffer, font, "lacrimosa", 16, 16, makecol(255,255,255),makecol(0,0,0));

				if (statetimer==30)
				{
					
					if (noteindex<notecount+4)
					{
						if (canon[noteindex]!=NONOTE && noteindex<notecount)
						{
							playnote(canon[noteindex]);
							std::cout<<canon[noteindex];
							Drop a(40+canon[noteindex]*6);
							drops.push_back(a);
						}
						if ((noteindex>=4) && (canon[noteindex-4]!=NONOTE))
						{
							if (px<=40+canon[noteindex-4]*6 && px+8>=40+canon[noteindex-4]*6+4)
							{
								playnote(canon[noteindex-4]-12);
								std::cout<<canon[noteindex-4];
								score++;
							}
							else
								score/=2;
						}

						
						noteindex++;
						statetimer=0;
						

					}
					else
					{
						gamestate=gs_postlude;
						if (score==notecount)
							prefacescreen=0;
						else if (score*4>=notecount*3)
							prefacescreen=1;
						else if (score*3>=notecount)
							prefacescreen=2;
						else if (score*6>notecount)
							prefacescreen=3;
						else if (score*12>notecount)
							prefacescreen=4;
						else
							prefacescreen=5;
								 
					}
				}
				
				if (key[KEY_LEFT] && px>2)
					px-=2;
				if (key[KEY_RIGHT] && px<150)
					px+=2;
				
				
				for (unsigned int i=0;i<drops.size();i++)
				{
					if (!drops[i].move())
					{
						drops.erase(drops.begin()+i);
						i--;
					}
				}
				
				
				for (unsigned int i=0;i<drops.size();i++)
				{
					drops[i].draw();
				}
				
				rectfill(buffer, px, 94, px+8, 102, makecol(255,100,150));
				
			
				break;
			case gs_postlude:
					switch (prefacescreen)
					{
						case 0:
							textout_ex(buffer, font, "I did my best,", 4, 16, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "I loved her,", 4, 44, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "but she left me.", 4, 58, makecol(255,255,255),makecol(0,0,0));
							break;
						case 1:
							textout_ex(buffer, font, "She said that", 4, 16, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "she loved me;", 4, 30, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "it was never", 4, 44, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "the same.", 4, 58, makecol(255,255,255),makecol(0,0,0));
							break;
						case 2:
							textout_ex(buffer, font, "After months", 4, 16, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "she smiled again,", 4, 30, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "but I never", 4, 44, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "forgave myself.", 4, 58, makecol(255,255,255),makecol(0,0,0));
							break;
						case 3:
							textout_ex(buffer, font, "I didn't know", 4, 16, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "what to do;", 4, 30, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "I don't know", 4, 44, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "why she loves me.", 4, 58, makecol(255,255,255),makecol(0,0,0));
							break;
						case 4:
							textout_ex(buffer, font, "She never did", 4, 16, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "stop crying.", 4, 30, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "She didn't know", 4, 44, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "how much I cared.", 4, 58, makecol(255,255,255),makecol(0,0,0));
							break;
						case 5:
							textout_ex(buffer, font, "I left her,", 4, 16, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "in the end.", 4, 30, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "I couldn't know", 4, 44, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "her sorrow.", 4, 58, makecol(255,255,255),makecol(0,0,0));
							break;					
					}
					if (key[KEY_SPACE])
					{
						if (spaceup)
						{
							quit=true;
						}
					}
					else
						spaceup=true;
				break;
		}
			
				
		/* control timing */
		while (ticks<1)
		{
			rest(0);
		}
		ticks=0;
		++frames;
		
		stretch_blit(buffer, screen, 0, 0, 160, 120, 0,0,640, 480);		
	}	
	
	
	deinit();
	return 0;
}
END_OF_MAIN()

void init() {
	int depth, res;
	allegro_init();
	depth = desktop_color_depth();
	if (depth == 0) depth = 32;
	set_color_depth(depth);
	res = set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 640, 480, 0, 0);
	if (res != 0) {
		allegro_message(allegro_error);
		exit(-1);
	}
	
	CGDisplayHideCursor(kCGDirectMainDisplay);
	
	install_timer();
	install_keyboard();
	install_mouse();
	
	if (install_sound(DIGI_AUTODETECT, MIDI_NONE, NULL) != 0) {
		allegro_message("Error initialising sound system\n%s\n", allegro_error);
	}
	
	
	sound = load_wav("note.wav");                       
          
	
	LOCK_FUNCTION(second_counter);
	LOCK_VARIABLE(fps);
	LOCK_VARIABLE(frames);
	LOCK_FUNCTION(ticker);
	LOCK_VARIABLE(ticks);
	
	
	frames=timewaster_delay=0;
	install_int_ex(second_counter, BPS_TO_TIMER(1));
	install_int_ex(ticker, BPS_TO_TIMER(30));
	
	
	
	buffer=create_bitmap(160,120);
	//        bg=create_bitmap(800,600);        
	
}

void deinit() {
	clear_keybuf();
	/* add other deinitializations here */
}
